var panel;
var dockForm;
var tree;


function OnReady() {
  panel.ReDock(); //if loading layouts eleminated this panel, the redock will restore it
  
  //remember to restore dock visibility if dock enabled/disabled
  var wasvis = Script.ReadSetting("Dock visible", "0");
  if (Wasvis == "1") {
    panel.Show();
    Script.WriteSetting("Dock visible", "");    
  }
  
  if (panel.PanelVisible) {
    OnShow(null);
  }
}

function OnExit() {
  //this is always a good idea with forms
  delete dockForm;
}

function OnDisabled() {
  //save docking panel visibility so that we know whether to forecefully show panel when plugin is re-enabled
  var wasvis = "0";
  if (panel.PanelVisible)
    wasvis = "1";
  Script.WriteSetting("Dock visible", wasvis);
  panel.Close();
}

function OnInstalled() {
  if (WeBuilder.BuildNumber < 194) {
    return "Newer editor version is required for this plugin to work";
  }
}

function OnShow(Sender) {
  //create panel form only if dock visible because TScriptTree is very, very slow
  CreatePanelForm(panel);
}

function ShowDock(Sender) {
  panel.Show();
}

function HideDock(Sender) {
  panel.Close();
}

function CreatePanelForm(panel) {
  if (dockForm == null) {
    dockForm = new TForm(WeBuilder);
    dockForm.parent = panel;
    dockForm.BorderStyle = bsNone;
    dockForm.Align = alClient;
    dockForm.Visible = true;

    tree = new TScriptTree(dockForm);
    tree.Parent = dockForm;
    tree.Align = alClient;
  }
}


//create these on script initialization so that their position can be loaded from layouts if previously saved there
panel = new TDockPanel("DockTree_TreePanel", "dockPanelFileExplorer");
panel.Caption = "Plugin Script Tree";
panel.OnShow = &OnShow; 

Script.ConnectSignal("ready", &OnReady);
Script.ConnectSignal("exit", &OnExit);
Script.ConnectSignal("disabled", &OnDisabled);
Script.ConnectSignal("installed", &OnInstalled);

Script.RegisterAction("Script Tree", "Show Dock", "", &ShowDock);
Script.RegisterAction("Script Tree", "Hide Dock", "", &HideDock);
